# std::logical_and

From cppreference.com
< cpp‎ | utility‎ | functional

Defined in header `<functional>` |  |
template< class T > struct logical_and; |  | (until C++14)
template< class T = void > struct logical_and; |  | (since C++14)

Function object for performing logical AND (logical conjunction). Effectively calls operator&& on type `T`.

### Specializations

The standard library provides a specialization of `std::logical_and` when `T` is not specified, which leaves the parameter types and return type to be deduced.

logical_and<void> | function object implementing x && y deducing argument and return types (class template specialization)

(since C++14)

### Member types

Type | Definition
`result_type`(deprecated in C++17) | `bool`
`first_argument_type`(deprecated in C++17) | `T`
`second_argument_type`(deprecated in C++17) | `T`

### Member functions

operator() | returns the logical AND of the two arguments (public member function)

## std::logical_and::operator()

bool operator()( const T& lhs, const T& rhs ) const; |  | (until C++14)
constexpr bool operator()( const T& lhs, const T& rhs ) const; |  | (since C++14)

Returns the logical AND of `lhs` and `rhs`.

### Parameters

lhs, rhs | - | values to compute logical AND of

### Return value

The result of lhs && rhs.

### Exceptions

(none)

### Possible implementation

    constexpr bool operator()(const T &lhs, const T &rhs) const
    {
        return lhs && rhs;
    }

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/functional/logical_and&oldid=83699"